
include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include comctl32.inc
include comdlg32.inc
include gdi32.inc
include masm32.inc
include debug.inc

includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib comctl32.lib
includelib comdlg32.lib
includelib gdi32.lib
includelib masm32.lib
includelib debug.lib

WinMain				PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc				PROTO :DWORD,:DWORD,:DWORD,:DWORD

;Find.dlg
IDD_FINDDLG			equ 2000
IDC_FINDTEXT		equ 2001
IDC_BTN_REPLACE		equ 2007
IDC_REPLACETEXT		equ 2002
IDC_REPLACESTATIC	equ 2009
IDC_BTN_REPLACEALL	equ 2008
IDC_CHK_WHOLEWORD	equ 2004
IDC_CHK_MATCHCASE	equ 2003
IDC_RBN_DOWN		equ 2005
IDC_RBN_UP			equ 2006

;RTFPrint.dlg
IDD_DLG				equ 1000
IDC_SBR				equ 1003
IDC_TBR				equ 1001
IDC_RED				equ 1002
IDB_TBRBMP			equ 1212
IDM_MENU			equ 10000

;RTFPrint.mnu
IDM_FILE_NEW		equ 10001
IDM_FILE_OPEN		equ 10002
IDM_FILE_SAVE		equ 10003
IDM_FILE_SAVEAS		equ 10004
IDM_FILE_PRINT		equ 10005
IDM_FILE_EXIT		equ 10006
IDM_EDIT_UNDO		equ 10101
IDM_EDIT_REDO		equ 10102
IDM_EDIT_DELETE		equ 10103
IDM_EDIT_CUT		equ 10104
IDM_EDIT_COPY		equ 10105
IDM_EDIT_PASTE		equ 10106
IDM_EDIT_SELECTALL	equ 10107
IDM_EDIT_FIND		equ 10108
IDM_EDIT_FINDNEXT	equ 10110
IDM_EDIT_FINDPREV	equ 10111
IDM_EDIT_REPLACE	equ 10109
IDM_VIEW_TOOLBAR	equ 10008
IDM_VIEW_STATUSBAR	equ 10009
IDM_OPTION_FONT		equ 10007
IDM_HELP_ABOUT		equ 10201

.const

;structure for ToolBar buttons
tbrbtns				TBBUTTON <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
					TBBUTTON <6,IDM_FILE_NEW,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <7,IDM_FILE_OPEN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <8,IDM_FILE_SAVE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
					TBBUTTON <0,IDM_EDIT_CUT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <1,IDM_EDIT_COPY,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <2,IDM_EDIT_PASTE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
					TBBUTTON <3,IDM_EDIT_UNDO,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <4,IDM_EDIT_REDO,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <5,IDM_EDIT_DELETE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
					TBBUTTON <12,IDM_EDIT_FIND,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <13,IDM_EDIT_REPLACE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
					TBBUTTON <14,IDM_FILE_PRINT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
					TBBUTTON <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
;Number of buttons in tbbtns
ntbrbtns			equ 18
BASE_DPI            equ     1440

.data
pbPointers			dd 40 DUP (-1)
RichEditDLL			db 'riched20.dll',0
ClassName			db 'DLGCLASS',0
AppName				db 'RichEdit editor',0
AboutMsg			db 'RadASM RichEdit editor',13,10,'KetilO (C) 2002',0
Replace				db 'Replace ..',0
OpenFileFail        db 'Cannot open the file',0
SaveFileFail		db 'Cannot save the file',0
WannaSave           db 'Want to save changes to',0Dh,0
NewFile             db '(Untitled)',0
szNULL				db 0
szFont				db 'Courier New',0
szWinSpoolDRV		DB "Winspool.drv", 0
szWinSpoolDLL		DB "Winspool.dll", 0
szOpenPrinterA		db 'OpenPrinterA', 0
szClosePrinter		db 'ClosePrinter', 0
szDocumentProperties	db 'DocumentPropertiesA', 0
Masm32RTF			db 'Masm32RTF.rtf', 0
rtf1				db  "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}", 13, 10
rtf2				db  "\viewkind4\uc1\pard\b\f0\fs20 "
rtf6				db  13, 10, "\par " 
rtf_tab				db  "\pard\tx1700\tx3800\tx5100\tx6400\tx7700\tx9000\tx10300\tx11600\tx12900 "
tab					db  "\tab "
page_break			db  "\page ", 13, 10
center_it			db	"\qc "
justify_it			db	'\qj '
left_it				db	'\ql '
right_it			db	'\qr '
underline			db  "\ul "
un_underline		db	"\ulnone "
bold_on				db  "\b "
bold_off			db  "\b0 "
italic_it			db	'\i '
plain_it			db	'\plain '
reg_text			db  "\fs20 "
med_text			db  "\fs24 "
big_text			db  "\fs20 "
doc_end				db  13, 10, "} ", 13, 10
win32asmpro			db	'Masm32ASM programmers'
centered			db	'Some are centrists'
lefters				db	'Some are aligned to the left'
righters			db	'Some are aligned to the right'
bolders				db	'Some are bold'
italics				db	'Some are italics'
aussies				db	'Some are Aussies'
dummy				db	'dummy \par '
SBOnPage2			db	'This should be on page 2'
j_page_break		db	'*page', 0
DocTitle			db	'RTFPrint Experiment!', 0

.data?

hRichEdDLL			dd ?
hInstance			dd ?
CommandLine			dd ?
hIcon				dd ?
hWnd				HWND ?
hREd				HWND ?
hFind				HWND ?
hPrinter			HANDLE ?
hDevmodeOut			HANDLE ?
dcPrint				HANDLE ?
hSpoolLib			HANDLE ?
pDevmodeOut			DD ?
pOpenPrinterA		DD ?
pClosePrinter		DD ?
pDocumentProperties	DD ?
pPrintDriver		DD ?
FileName			db MAX_PATH dup(?)
;structure for DateTimePicker
iccex				INITCOMMONCONTROLSEX <?>
m_psd				PAGESETUPDLG <?>		;to determine printer page capabilities and adjust page margins
m_Paper             POINT <?>          ; " "
;minmargin			RECT <?>
;margin				RECT <?>           ; " "
m_MinMargin         RECT <?>
m_Margin            RECT <?>
fView				dd ?
TabSize				dd ?
lfnt				LOGFONT <?>
hFont				dd ?
rgb					dd ?
nobw				dd ?
landscape			dd ?
NumOfCopies			dd ?
pPrintInfo			db 80 dup (?)